config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  resources :tenants
  resources :users

  resources :properties
  get 'advertised', to: 'properties#advertised_properties'

  resources :landlords

  resources :tenancies
  get 'due_this_month', to: 'tenancies#due_this_month'

  controller :sessions do
    get 'login' => :new, as: :login
    post 'login' => :create
    delete 'logout' => :destroy, as: :logout
  end

  root 'sessions#new'
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/property.rb
# frozen_string_literal: true

class Property < ApplicationRecord
  PROPERTY_NAME_MAX_LENGTH = 100
  PROPERTY_ADDRESS_MAX_LENGTH = 500

  # rubocop:disable Layout/LineLength
  # rubocop:enable Layout/LineLength

  validates :property_name, presence: true
  validates :property_name, uniqueness: { case_sensitive: false }
  validates :property_name, length: { maximum: PROPERTY_NAME_MAX_LENGTH,
                                      if: :property_name }
  validates :property_address, presence: true
  validates :property_address, length: { maximum: PROPERTY_ADDRESS_MAX_LENGTH,
                                         if: :property_address }

  has_many :landlords_properties
  has_many :landlords, through: :landlords_properties, dependent: :destroy

  validate :validate_landlords

  has_one :tenancy, inverse_of: :property

  scope :not_rented, -> { joins('LEFT JOIN tenancies ON properties.id = tenancies.property_id')
    .where('tenancies.id IS NULL') }

  def validate_landlords
    errors.add(:landlords, "Pick at least one landlord") if landlords.size < 1
  end
end

app/controllers/properties_controller.rb
# frozen_string_literal: true

class PropertiesController < ApplicationController
  before_action :set_property, only: %i[show edit update destroy]
  skip_before_action :authenticate_user!, only: [:advertised_properties]

  def index
    @properties = Property.all
  end

  def advertised_properties
    @properties = Property.not_rented
  end

  def show; end

  def new
    @property = Property.new
    @landlord = @property.landlords.new
  end

  def edit; end

  def create
    @property = Property.create(property_params)
    if @property.persisted?
      flash[:success] = 'Property was successfully created.'
      redirect_to @property
    else
      render :new, status: :unprocessable_entity
    end
  end

  def update
    if @property.update(property_params)
      flash[:success] = 'Property was successfully updated.'
      redirect_to @property
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def destroy
    @property.destroy

    redirect_to properties_url, notice: 'Property was successfully destroyed.'
  end

  private

  def set_property
    @property = Property.find(params[:id])
  end

  def property_params
    params.require(:property).permit(
      :property_name,
      :property_address,
      :advertised_monthly_rent,
      landlord_ids: []
    )
  end
end

app/helpers/properties_helper.rb
# frozen_string_literal: true

module PropertiesHelper
end

app/views/properties/_form.html.erb
<%= form_with(model: property, local: true) do |form| %>
  <div class="field">
    <%= form.label :property_name %>

    <%= form.text_field :property_name %>

    <% if property.errors[:property_name] %>
      <% property.errors[:property_name].each do |message| %>
        <p class="errorMessage">
          <%= message %>
        </p>
      <% end %>
    <% end %>
  </div>

  <div class="field">
    <%= form.label :property_address %>

    <%= form.text_area :property_address, rows: 10 %>

    <% if property.errors[:property_address] %>
      <% property.errors[:property_address].each do |message| %>
        <p class="errorMessage">
          <%= message %>
        </p>
      <% end %>
    <% end %>
  </div>

  <div class="field">
    <%= form.label 'Pick landlord(s)' %>
    <br/>
    <%= form.select :landlord_ids, options_for_select(Landlord.all.collect{ |u| [u.email, u.id] },
      { selected: property.landlord_ids }),{prompt: "Please select"}, {multiple: true, size: 3}%>

    <% if property.errors %>
      <% property.errors[:landlords].each do |message| %>
        <p class="errorMessage">
          <%= message %>
        </p>
      <% end %>
    <% end %>
  </div>

  <div class="field">
    Can't find landlord you're looking for?
  <%= link_to 'Add them'.html_safe, new_landlord_path %>
  </div>

  <div class="field">
    <%= form.label :advertised_monthly_rent %>

    <%= form.number_field :advertised_monthly_rent, min: 0.0, step: :any %>

    <% if property.errors[:advertised_monthly_rent] %>
      <% property.errors[:advertised_monthly_rent].each do |message| %>
        <p class="errorMessage">
          <%= message %>
        </p>
      <% end %>
    <% end %>
  </div>

  <div class="actions">
    <% if property.persisted? %>
      <button type="submit" name="commit" class="addButton">
        <i class="fa fa-floppy-o" aria-hidden="true"></i>Update Property
      </button>

      <%= link_to '<i class="fa fa-times-circle" aria-hidden="true"></i>Cancel'.html_safe, property, class: "destroyButton" %>
    <% else %>
      <button type="submit" name="commit" class="addButton">
        <i class="fa fa-floppy-o" aria-hidden="true"></i>Create Property
      </button>
      <%= link_to '<i class="fa fa-times-circle" aria-hidden="true"></i>Cancel'.html_safe, properties_path, class: "destroyButton" %>
    <% end %>
  </div>
<% end %>

app/views/properties/advertised_properties.html.erb
<section class='scaffold'>
   <h2>Properties to let</h2>
   <% unless current_user.present? %>
    <p><%= link_to 'Admin Login', login_path %></p>
   <% end %>
   <% if @properties.any? %>
      <table class="scaffoldListTable">
        <thead>
        <tr>
          <th>Property Name</th>
          <th>Rent</th>
        <tr>
        </thead>
        <tbody>
          <% @properties.each do |property| %>
            </tr>
              <td><%= property.property_name %></td>
              <td><%= property.advertised_monthly_rent.presence || 'Not Disclosed' %></td>
            </tr>
          <% end %>
        </tbody>
      </table>
    <% else %>
    We're Sorry. There are no properties to let, at the moment. Check back another time.
  <% end %>
</section>

app/views/properties/edit.html.erb
<section class='scaffold'>
  <h2 class="breadcrumbs">
    <%= link_to "Properties", properties_path %>
    <i class="fa fa-long-arrow-right" aria-hidden="true"></i>
    <%= link_to @property.property_name, @property %>
    <i class="fa fa-long-arrow-right" aria-hidden="true"></i>
    Edit
  </h2>

    <%= render "form", property: @property %>
</section>

app/views/properties/index.html.erb
<section class='scaffold'>
  <h2 class="breadcrumbs">Properties</h2>

  <p>
    <%= link_to '<i class="fa fa-plus-circle" aria-hidden="true"></i>New Property'.html_safe, new_property_path, class: "addButton" %>
  </p>

  <table class="scaffoldListTable">
    <thead>
      <tr>
        <th>Property name</th>
        <th>Property address</th>
        <th>Advertised rent</th>
        <th>Landlords</th>
        <th colspan="2">Actions</th>
      </tr>
    </thead>

    <tbody>
      <% @properties.each do |property| %>
        <tr>
          <td><%= link_to property.property_name, property %></td>
          <td>
            <pre><%= property.property_address %></pre>
          </td>
          <td><%= property.advertised_monthly_rent || 0.0 %></td>
          <td>
            <% property.landlords.each do |landlord| %>
              <li><%= link_to "#{landlord.first_name+" "+landlord.last_name+", "+landlord.email}", landlord %></li>
            <% end %>
          </td>

          <td><%= link_to '<i class="fa fa-pencil" aria-hidden="true"></i>'.html_safe, edit_property_path(property), title: "Edit Property" %></td>

          <td><%= link_to '<i class="fa fa-trash" aria-hidden="true"></i>'.html_safe, property,
          method: :delete, data: { confirm: "Are you sure want to delete #{property.property_name}?" } %></td>
        </tr>
      <% end %>
    </tbody>
  </table>

  <p>
    <%= link_to '<i class="fa fa-plus-circle" aria-hidden="true"></i>New Property'.html_safe, new_property_path, class: "addButton" %>
  </p>
</section>

app/views/properties/new.html.erb
<section class='scaffold'>
  <h2 class="breadcrumbs">
    <%= link_to "Properties", properties_path %>
    <i class="fa fa-long-arrow-right" aria-hidden="true"></i>
    New Property
  </h2>

    <%= render "form", property: @property %>
</section>

app/views/properties/show.html.erb
<section class='scaffold'>
  <h2 class="breadcrumbs">
    <%= link_to "Properties", properties_path %>
    <i class="fa fa-long-arrow-right" aria-hidden="true"></i>
    <%= @property.property_name %>
  </h2>

  <p>
    <%= link_to '<i class="fa fa-plus-circle" aria-hidden="true"></i>New Property'.html_safe, new_property_path, class: "addButton" %>
  </p>

  <table class="scaffoldDataTable">
    <tbody>
      <tr>
        <th>Property Name</th>

        <th>Property Address</th>

        <th>Advertised Rent</th>

        <th>Created</th>

        <th>Last Updated</th>
      </tr>

      <tr>
        <td><%= @property.property_name %></td>

        <td>
          <pre><%= @property.property_address %></pre>
        </td>

        <td><%= @property.advertised_monthly_rent.presence || 0.0 %></td>

        <td><%= @property.created_at.strftime("%H:%M:%S %A %d %B %Y") %></td>

        <td><%= @property.updated_at.strftime("%H:%M:%S %A %d %B %Y") %></td>
      </tr>

      <tr>
        <th>Landlords</th>
      </tr>
      <% @property.landlords.each do |landlord| %>
        <tr>
          <td><%= link_to "#{landlord.first_name+" "+landlord.last_name+", "+landlord.email}", landlord %></td>
        </tr>
      <% end %>

      <% unless @property.tenancy.blank? %>
        <tr>
          <th>Tenants  <%= link_to 'Edit Tenancy'.html_safe, edit_tenancy_path(@property.tenancy)%> </th>
        </tr>
        <% @property.tenancy.tenants.each do |tenant| %>
          <tr>
            <td><%= link_to "#{tenant.first_name+" "+tenant.last_name+", "+tenant.email}", tenant %></td>
          </tr>
        <% end %>
      <% else %>
        <tr>
          <th>Tenants</th>
        </tr>
        <tr>
          <td>No tenancies. <%= link_to 'Add one'.html_safe, new_tenancy_path(property_id: @property.id), method: :get %></td>
        </tr>
      <% end %>
    </tbody>
  </table>

  <p>
    <%= link_to '<i class="fa fa-pencil" aria-hidden="true"></i>Edit Property'.html_safe, edit_property_path(@property), class: "defaultButton" %>
  </p>
</section>